
#include <stdlib.h>
#include <stdio.h>

typedef int opcode_t;
static void **ops_addr;
struct op_lib_t {
    int nops;
    void **func_table;
};

opcode_t *
cg_math_core(opcode_t *cur_opcode)
{
    static void *lops_addr[] = {
	&&PC_0,
	&&PC_1,
	NULL
    };

    if (!ops_addr) {
	ops_addr = lops_addr;
	return 0;
    }

    goto *ops_addr[*cur_opcode];

PC_0: /* Parrot_add5_ic */
    {
	printf("add5 5+%d=%d\n", cur_opcode[1], cur_opcode[1] + 5);
	goto *ops_addr[*(cur_opcode += 2)];
    }

PC_1: /* Parrot_sub5_ic */
    {
	printf("sub5 %d-5=%d\n", cur_opcode[1], cur_opcode[1] - 5);
	goto *ops_addr[*(cur_opcode += 2)];
    }
}
static struct op_lib_t math_op_lib = {
    2,
    NULL
};

struct op_lib_t * math_ops_init(int i)
{
    if (i == 1) {
	cg_math_core(0);
	math_op_lib.func_table = ops_addr;
    }
    else if (i == 0) {
    }
    else {
	ops_addr = (void **)i;
    }
    return &math_op_lib;
}

